#ifndef ZP_OPTIMIZER_H
#define ZP_OPTIMIZER_H

#include "Parser.h"

namespace zp
{
    // forward declarations
    enum class Instruction : char;

    struct Block;
    struct InstructionBlock;
    struct UnionBlock;
    struct Loop;

    class AstVisitor;

    struct BlockInstruction;

    class Optimizer;
}


class zp::AstVisitor
{
public:
    std::unique_ptr<BlockInstruction> visit(Block& block);

    virtual std::unique_ptr<BlockInstruction>
        visitLoop(Loop& loop) = 0;
    virtual std::unique_ptr<BlockInstruction>
        visitInstructionBlock(InstructionBlock& ib) = 0;
    virtual std::unique_ptr<BlockInstruction>
        visitUnionBlock(UnionBlock& ub) = 0;
};


struct zp::BlockInstruction
{

};


class zp::Optimizer :
    public AstVisitor
{
public:
    std::unique_ptr<BlockInstruction> visitLoop(Loop& loop) override;
    std::unique_ptr<BlockInstruction> visitInstructionBlock(InstructionBlock& ib) override;
    std::unique_ptr<BlockInstruction> visitUnionBlock(UnionBlock& ub) override;

};


#endif /* ZP_OPTIMIZER_H */
